var chs = 0;
var errs = 0;
var lstLen = 0;
var timeStart = 0;
var timing = false;
var elErrs = null; // error count element
var elRate = null; // error rate element

var totChars = 0;

if (!Date.now) {
    Date.now = function() { return new Date().getTime(); }
}

// non-empty drillId is used as flag that test is running
var drillId  = "";

function iterateInputs(func){
 	// call func for all inputs in drill
	var i = 0;
	do {
		var inId = "input_" + drillId + "_" + i;
		var inEl  = document.getElementById(inId);
		if(inEl){
			func(inEl);
		}
		i++;
	}while(inEl);
}

function stopDrill(passed){

	var statEl  = document.getElementById("status_"+ drillId);
	if(!passed ){
		statEl.textContent='Failed';
		statEl.classList.add("failRes");
		statEl.classList.remove("passRes");
		statEl.classList.remove("incompleteRes");
	}else{
		statEl.textContent='Passed';
		statEl.classList.add("passRes");
		statEl.classList.remove("failRes");
		statEl.classList.remove("incompleteRes");
	}

	// disable all inputs in drill
    iterateInputs(function (el){el.disabled=true;});

	// update wpm
	timing = false;
	// in milliseconds
	var timeTaken =  Math.floor( ( Date.now()  - timeStart) / 1000);
	// use word = 5chars, standard for typing
	var wpm = ( (totChars / 5) / timeTaken) * 60;
	document.getElementById("wpm_" + drillId).textContent=wpm.toFixed(0);
	// enable start button
	document.getElementById("start_" + drillId).disabled=false;
	drillId = ""; // flag no test running
} // function stopDrill

function keyInput(ele){
	if(!timing){
        // start timer
	    timeStart = Date.now() ;
		timing = true;
	}
	var inId = ele.id;
	var baseId  = inId.slice(6) ;

	var tId = "text_" + baseId;

	var typed = ele.value;
	var expect = document.getElementById(tId).textContent;
	var lenTyped =  typed.length;
	var lstT =typed.charAt(lenTyped-1);
	var lstE =expect.charAt(lenTyped-1);
	// don't count error if backspaced
    // crude detection of backspace
    if(lstLen == lenTyped+1){
        chs--;
    } else {
        chs++;
      	if (lstT != lstE){
			errs++;
			ele.classList.add("errInput");
		}else{
			ele.classList.remove("errInput");
		}
    }
	lstLen = lenTyped;
	// show percent as proportion of total chars, not typed chars, so can't simply retype to get % down
	var perErrs = (errs / totChars) * 100;

	elErrs.textContent = errs;
	elRate.textContent = perErrs.toFixed(1) + '%';

	if(chs>=totChars){
		// test finished
		stopDrill(perErrs<3);
	}
} // keyInput

function startDrill(ele){
	if(drillId != ""){
		alert("Only one drill can be run at a time, the previous one will be finished.");
		stopDrill(false);
	}
	var btnId = ele.id;

	drillId  = btnId.slice(6) ; // start_
	totChars = document.getElementById("tot_" + drillId).textContent;

	ele.disabled=true;
	chs =0;
	errs = 0;
	lstLen = 0;
	// reset all inputs in drill
    iterateInputs(
        function (el){
            el.value = '';
            el.classList.remove("errInput");
            el.disabled=false;
        }
    );


	elErrs = document.getElementById("errs_" + drillId);
	elErrs.textContent='-';
    elRate = document.getElementById("perErrs_"+ drillId);
    elRate.textContent= '-';
	document.getElementById("wpm_" + drillId).textContent='-';

	var statEl  = document.getElementById("status_"+ drillId);

	statEl.textContent='Incomplete';
	statEl.classList.remove("failRes");
	statEl.classList.remove("passRes");
	statEl.classList.add("incompleteRes");
} // function startDrill


// handle enter by going to next input
function keypress(e)
{
	if (!e) e= event;

	//    handle enter by going to next edit, simulating return key
	if(e.which == 13){
		// return key
		var id = e.target.id;
		// of form id_n
		// won't work for > 20 edits, on edits ending 19, 29 etc
		var baseId  = id.slice(0,id.length-1) ;
		var endId =  id.slice(id.length-1) ;

		endId++;

		// next one ends with consecutive number
		var newId= baseId +  endId;
		var el = document.getElementById(newId);
		if(el){
			el.focus();
			el.select();
		}
	}
    /* to disable backspace
    if(e.which === 8){
    ...

    }
    */
}

